;CodeVisionAVR C Compiler V1.24.4a Standard
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com

;Chip type              : ATmega128
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : No
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM


	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM


	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM


	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "step_mot.vec"
	.INCLUDE "step_mot.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30
	OUT  RAMPZ,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x500
;       1 /*********************************************
;       2 file name: step_mot.c
;       3 BY RealSYS KCO	2001.1.3
;       4 
;       5 function: 
;       6 	- A/D ch0 Input(interrupt based) => LCD display
;       7 	- 7SEGMENT display : A/D ch0 value    
;       8 	- DC motor speed adjust using PWM2 duty change
;       9 	- STEP motor speed adjust using Timer/counter1 Compare Match Interrupt
;      10 
;      11 	cable connection:
;      12 	CN33(1):VR <==> CN8(1):ADC0
;      13 	CN12(1~4):PA <==> CN31(1~4):LCD-con
;      14 	CN12(5~8):PA <==> CN32(5~8):LCD-dat	 
;      15 	
;      16 	CN11(1~8):PC <==> CN29(1~8):SEG_data
;      17 	CN7(1~4):PD <==> CN27(1~4):SEG_scan
;      18 	
;      19 	CN4(8):PWM2 <==> CN26(1): DC_mot   
;      20 	
;      21 	CN5(5~8):PE <==> CN23(1~4): STEP_mot
;      22 
;      23 	Chip type           : ATmega128
;      24 	Clock frequency     : 16.000000 MHz
;      25 *********************************************/
;      26 #include <mega128.h>
;      27 #include <delay.h>		// for delay_ms() function
;      28 #include <stdio.h>		// for sprintf() function
;      29 // Alphanumeric LCD Module functions
;      30 #asm
;      31    .equ __lcd_port=0x1B	; Port A
   .equ __lcd_port=0x1B	; Port A
;      32 #endasm
;      33 #include <lcd.h>		// for LCD function
;      34 #define FIRST_ADC_INPUT 0
;      35 #define LAST_ADC_INPUT 0
;      36 
;      37 #define	BYTE	unsigned char
;      38 #define	WORD	unsigned int
;      39 
;      40 #define	SCAN_OFF (PORTD |= 0x0f)
;      41 #define	SCAN0	(PORTD.0 = 0)
;      42 #define	SCAN1	(PORTD.1 = 0)
;      43 #define	SCAN2	(PORTD.2 = 0)
;      44 #define	SCAN3	(PORTD.3 = 0)
;      45 
;      46 #define	SEG_DATA(val)	(PORTC = val)
;      47 
;      48 flash BYTE 	seg_hex[] = /* HEX font */

	.CSEG
;      49 	{0xc0,0xf9,0xa4,0xb0,0x99,0x92,0x82,0xf8,0x80,0x90,0x88,0x83,0xc6,0xa1,0x86,0x8e};
;      50 BYTE	seg_data[4]= { 0xbf,0xbf,0xbf,0xbf };

	.DSEG
_seg_data:
	.BYTE 0x4
;      51 BYTE	scan_cnt=0;	
;      52 
;      53 int		m_cnt=0,t_cnt1=0;
;      54 
;      55 /*BYTE	sm_data[] = { 0xc0,0x90,0x30,0x60 };*/
;      56 BYTE	sm_data[] = { 0x10,0x20,0x40,0x80 };
_sm_data:
	.BYTE 0x4
;      57 
;      58 unsigned int adc_data[LAST_ADC_INPUT-FIRST_ADC_INPUT+1];
_adc_data:
	.BYTE 0x2
;      59 
;      60 // ADC interrupt service routine
;      61 // with auto input scanning
;      62 #pragma savereg-
;      63 interrupt [ADC_INT] void adc_isr(void){

	.CSEG
_adc_isr:
;      64 #asm
;      65     push r26
    push r26
;      66     push r27
    push r27
;      67     push r30
    push r30
;      68     push r31
    push r31
;      69     in   r30,sreg
    in   r30,sreg
;      70     push r30
    push r30
;      71 #endasm
;      72 register static unsigned char input_index=0;

	.DSEG

	.CSEG
;      73 // Read the ADC conversion result
;      74 adc_data[input_index]=ADCW;
	MOV  R30,R9
	LDI  R26,LOW(_adc_data)
	LDI  R27,HIGH(_adc_data)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	IN   R30,0x4
	IN   R31,0x4+1
	ST   X+,R30
	ST   X,R31
;      75 // Select next ADC input
;      76 if (++input_index>(LAST_ADC_INPUT-FIRST_ADC_INPUT))
	INC  R9
	LDI  R30,LOW(0)
	CP   R30,R9
	BRSH _0x5
;      77    input_index=0;
	CLR  R9
;      78 #ifdef BANDGAP
;      79 ADMUX=input_index+FIRST_ADC_INPUT|0x40;
;      80 #else
;      81 ADMUX=input_index+FIRST_ADC_INPUT;
_0x5:
	MOV  R30,R9
	OUT  0x7,R30
;      82 #endif
;      83 // Start the next ADC conversion
;      84 ADCSRA.6=1;
	SBI  0x6,6
;      85 #asm
;      86     pop  r30
    pop  r30
;      87     out  sreg,r30
    out  sreg,r30
;      88     pop  r31
    pop  r31
;      89     pop  r30
    pop  r30
;      90     pop  r27
    pop  r27
;      91     pop  r26
    pop  r26
;      92 #endasm
;      93 }
	RETI
;      94 #pragma savereg+
;      95 
;      96 interrupt [TIM1_COMPA] void TIM1_COMPA_isr(void) 
;      97 { 
_TIM1_COMPA_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      98 int	data;
;      99 	data = 1023-adc_data[0] + 10; 
	ST   -Y,R17
	ST   -Y,R16
;	data -> R16,R17
	LDS  R26,_adc_data
	LDS  R27,_adc_data+1
	LDI  R30,LOW(1023)
	LDI  R31,HIGH(1023)
	SUB  R30,R26
	SBC  R31,R27
	ADIW R30,10
	__PUTW1R 16,17
;     100 	OCR1A = data;		// Interrupt gen. interval
	__OUTWR 16,17,42
;     101 	
;     102 	t_cnt1++;  
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 7,8,30,31
;     103 	if(adc_data[0]==0) PORTE &= 0x0f;
	LDS  R30,_adc_data
	LDS  R31,_adc_data+1
	SBIW R30,0
	BRNE _0x6
	IN   R30,0x3
	ANDI R30,LOW(0xF)
	RJMP _0x74
;     104 	else	PORTE = sm_data[t_cnt1 & 0x03];
_0x6:
	__GETW1R 7,8
	ANDI R30,LOW(0x3)
	ANDI R31,HIGH(0x3)
	SUBI R30,LOW(-_sm_data)
	SBCI R31,HIGH(-_sm_data)
	LD   R30,Z
_0x74:
	OUT  0x3,R30
;     105 }
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;     106 
;     107 void	init_timer(void){
_init_timer:
;     108 	TCNT0 = -16;	/* 64usec * 16 = 1.024 msec period */
	LDI  R30,LOW(240)
	OUT  0x32,R30
;     109 	TCCR0 = 7;		/* CK(16MHz)/1024 = 15.625kHz : 64usec */
	LDI  R30,LOW(7)
	OUT  0x33,R30
;     110 	TIMSK = 1;		/* TOIE0 = 1 */
	LDI  R30,LOW(1)
	OUT  0x37,R30
;     111 
;     112 	OCR1AL = 160;		// 10 msec
	LDI  R30,LOW(160)
	OUT  0x2A,R30
;     113 	TCNT1 = 0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
;     114 	TCCR1B = 0x0d;	/* CTC1=1(Match clear), CK(16MHz)/1024 = 15.625kHz : 64usec*/
	LDI  R30,LOW(13)
	OUT  0x2E,R30
;     115 	TIMSK |= 0x10;	/* OCIE1A = 1 ; Timer/Counter1 Output Compare Match Interrupt Enable */
	IN   R30,0x37
	ORI  R30,0x10
	OUT  0x37,R30
;     116 	
;     117 	TCCR2 = 0x61;	/* Non-inv 8bit PWM, CK */
	LDI  R30,LOW(97)
	OUT  0x25,R30
;     118 	OCR2 = 0;
	LDI  R30,LOW(0)
	OUT  0x23,R30
;     119 }
	RET
;     120 interrupt [TIM0_OVF] void TIM0_OVF_isr(void){
_TIM0_OVF_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     121 	TCNT0 = -16;	/* 64usec * 16 = 1.024 msec period */
	LDI  R30,LOW(240)
	OUT  0x32,R30
;     122 
;     123 	/* 7segment display */
;     124 	SCAN_OFF;
	IN   R30,0x12
	ORI  R30,LOW(0xF)
	OUT  0x12,R30
;     125 	SEG_DATA(seg_data[scan_cnt]);	/* Seg Data out */
	MOV  R30,R4
	LDI  R31,0
	SUBI R30,LOW(-_seg_data)
	SBCI R31,HIGH(-_seg_data)
	LD   R30,Z
	OUT  0x15,R30
;     126 	switch(scan_cnt){				// Seg Scan
	MOV  R30,R4
;     127 		case 0:	SCAN0;	break;
	CPI  R30,0
	BRNE _0xB
	CBI  0x12,0
	RJMP _0xA
;     128 		case 1:	SCAN1;	break;
_0xB:
	CPI  R30,LOW(0x1)
	BRNE _0xC
	CBI  0x12,1
	RJMP _0xA
;     129 		case 2:	SCAN2;	break;
_0xC:
	CPI  R30,LOW(0x2)
	BRNE _0xD
	CBI  0x12,2
	RJMP _0xA
;     130 		case 3:	SCAN3;	break;
_0xD:
	CPI  R30,LOW(0x3)
	BRNE _0xF
	CBI  0x12,3
;     131 		default: break;
_0xF:
;     132 	}                                          
_0xA:
;     133 	scan_cnt++;					
	INC  R4
;     134 	if(scan_cnt > 3) scan_cnt = 0;
	LDI  R30,LOW(3)
	CP   R30,R4
	BRSH _0x10
	CLR  R4
;     135 }
_0x10:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     136 void	disp_seg4(WORD d){
_disp_seg4:
;     137 	seg_data[0] = seg_hex[(d>>12) & 0x0f];
	LDI  R26,LOW(_seg_hex*2)
	LDI  R27,HIGH(_seg_hex*2)
	LDD  R30,Y+1
	SWAP R30
	CALL SUBOPT_0x0
	STS  _seg_data,R30
;     138 	seg_data[1] = seg_hex[(d>>8) & 0x0f];
	LDI  R26,LOW(_seg_hex*2)
	LDI  R27,HIGH(_seg_hex*2)
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	CALL SUBOPT_0x0
	__PUTB1MN _seg_data,1
;     139 	seg_data[2] = seg_hex[(d>>4) & 0x0f];
	LDI  R26,LOW(_seg_hex*2)
	LDI  R27,HIGH(_seg_hex*2)
	LD   R30,Y
	LDD  R31,Y+1
	CALL __LSRW4
	CALL SUBOPT_0x0
	__PUTB1MN _seg_data,2
;     140 	seg_data[3] = seg_hex[d & 0x0f];
	LDI  R26,LOW(_seg_hex*2)
	LDI  R27,HIGH(_seg_hex*2)
	LD   R30,Y
	LDD  R31,Y+1
	CALL SUBOPT_0x0
	__PUTB1MN _seg_data,3
;     141 }
	ADIW R28,2
	RET
;     142 
;     143 void main(void){
_main:
;     144 // Declare your local variables here
;     145 char	sbuf[20];
;     146 
;     147 // Input/Output Ports initialization
;     148 // Port B
;     149 DDRB=0xff;
	SBIW R28,20
;	sbuf -> Y+0
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     150 PORTB=0x00; 
	LDI  R30,LOW(0)
	OUT  0x18,R30
;     151 // Port C
;     152 DDRC=0xff;
	LDI  R30,LOW(255)
	OUT  0x14,R30
;     153 PORTC=0xff;
	OUT  0x15,R30
;     154 
;     155 // Port D
;     156 DDRD=0xff;
	OUT  0x11,R30
;     157 PORTD=0xff;
	OUT  0x12,R30
;     158 
;     159 // Port E
;     160 DDRE=0xfe;
	LDI  R30,LOW(254)
	OUT  0x2,R30
;     161 PORTE=0x0f;
	LDI  R30,LOW(15)
	OUT  0x3,R30
;     162 
;     163 // ADC initialization
;     164 // ADC Clock frequency: 187.500 kHz
;     165 ADMUX=FIRST_ADC_INPUT;
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     166 ADCSRA=0xCD;
	LDI  R30,LOW(205)
	OUT  0x6,R30
;     167 
;     168 // LCD module initialization
;     169 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     170 
;     171 // Timer init.
;     172 init_timer();
	CALL _init_timer
;     173 
;     174 // Global enable interrupts
;     175 #asm("sei")
	sei
;     176 
;     177 while (1)
_0x11:
;     178 	{
;     179 	m_cnt++;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 5,6,30,31
;     180 
;     181 	lcd_gotoxy(0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL SUBOPT_0x1
;     182 	sprintf(sbuf,"ADC0=%u(%03X)",adc_data[0],adc_data[0]);
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x2
	CALL SUBOPT_0x2
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
;     183 	lcd_puts(sbuf);
	CALL SUBOPT_0x3
;     184 
;     185 	lcd_gotoxy(0,1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	CALL SUBOPT_0x1
;     186 	sprintf(sbuf,"OCR1A=%4u",OCR1A);
	__POINTW1FN _0,14
	ST   -Y,R31
	ST   -Y,R30
	IN   R30,0x2A
	IN   R31,0x2A+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;     187 	lcd_puts(sbuf);
	CALL SUBOPT_0x3
;     188 
;     189 	disp_seg4(adc_data[0]);	// 7segment display
	LDS  R30,_adc_data
	LDS  R31,_adc_data+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _disp_seg4
;     190 	
;     191 	OCR2 = adc_data[0]>>2;	// DC motor speed control
	LDS  R30,_adc_data
	LDS  R31,_adc_data+1
	CALL __LSRW2
	OUT  0x23,R30
;     192 
;     193 	delay_ms(100);	   		// delay 0.1 sec
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     194 	};
	RJMP _0x11
;     195 }
	ADIW R28,20
_0x14:
	RJMP _0x14

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	put:
	LD   R26,Y
	LDD  R27,Y+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x15
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	SBIW R30,1
	LDD  R26,Y+2
	STD  Z+0,R26
	RJMP _0x16
_0x15:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _putchar
_0x16:
	ADIW R28,3
	RET
__print_G2:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R16,0
_0x17:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x19
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x1D
	CPI  R19,37
	BRNE _0x1E
	LDI  R16,LOW(1)
	RJMP _0x1F
_0x1E:
	CALL SUBOPT_0x4
_0x1F:
	RJMP _0x1C
_0x1D:
	CPI  R30,LOW(0x1)
	BRNE _0x20
	CPI  R19,37
	BRNE _0x21
	CALL SUBOPT_0x4
	LDI  R16,LOW(0)
	RJMP _0x1C
_0x21:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x22
	LDI  R17,LOW(1)
	RJMP _0x1C
_0x22:
	CPI  R19,43
	BRNE _0x23
	LDI  R21,LOW(43)
	RJMP _0x1C
_0x23:
	CPI  R19,32
	BRNE _0x24
	LDI  R21,LOW(32)
	RJMP _0x1C
_0x24:
	RJMP _0x25
_0x20:
	CPI  R30,LOW(0x2)
	BRNE _0x26
_0x25:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x27
	ORI  R17,LOW(128)
	RJMP _0x1C
_0x27:
	RJMP _0x28
_0x26:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x1C
_0x28:
	CPI  R19,48
	BRLO _0x2B
	CPI  R19,58
	BRLO _0x2C
_0x2B:
	RJMP _0x2A
_0x2C:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x1C
_0x2A:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x30
	CALL SUBOPT_0x5
	LD   R30,X
	CALL SUBOPT_0x6
	RJMP _0x31
_0x30:
	CPI  R30,LOW(0x73)
	BRNE _0x33
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	CALL _strlen
	MOV  R16,R30
	RJMP _0x34
_0x33:
	CPI  R30,LOW(0x70)
	BRNE _0x36
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	CALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x34:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x37
_0x36:
	CPI  R30,LOW(0x64)
	BREQ _0x3A
	CPI  R30,LOW(0x69)
	BRNE _0x3B
_0x3A:
	ORI  R17,LOW(4)
	RJMP _0x3C
_0x3B:
	CPI  R30,LOW(0x75)
	BRNE _0x3D
_0x3C:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x3E
_0x3D:
	CPI  R30,LOW(0x58)
	BRNE _0x40
	ORI  R17,LOW(8)
	RJMP _0x41
_0x40:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x6F
_0x41:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x3E:
	SBRS R17,2
	RJMP _0x43
	CALL SUBOPT_0x5
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x44
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x44:
	CPI  R21,0
	BREQ _0x45
	SUBI R16,-LOW(1)
	RJMP _0x46
_0x45:
	ANDI R17,LOW(251)
_0x46:
	RJMP _0x47
_0x43:
	CALL SUBOPT_0x5
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x47:
_0x37:
	SBRC R17,0
	RJMP _0x48
_0x49:
	CP   R16,R20
	BRSH _0x4B
	SBRS R17,7
	RJMP _0x4C
	SBRS R17,2
	RJMP _0x4D
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x4E
_0x4D:
	LDI  R19,LOW(48)
_0x4E:
	RJMP _0x4F
_0x4C:
	LDI  R19,LOW(32)
_0x4F:
	CALL SUBOPT_0x4
	SUBI R20,LOW(1)
	RJMP _0x49
_0x4B:
_0x48:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x50
_0x51:
	CPI  R18,0
	BREQ _0x53
	SBRS R17,3
	RJMP _0x54
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x75
_0x54:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x75:
	ST   -Y,R30
	CALL SUBOPT_0x8
	CPI  R20,0
	BREQ _0x56
	SUBI R20,LOW(1)
_0x56:
	SUBI R18,LOW(1)
	RJMP _0x51
_0x53:
	RJMP _0x57
_0x50:
_0x59:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x5B
	SBRS R17,3
	RJMP _0x5C
	SUBI R19,-LOW(7)
	RJMP _0x5D
_0x5C:
	SUBI R19,-LOW(39)
_0x5D:
_0x5B:
	SBRC R17,4
	RJMP _0x5F
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x61
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x60
_0x61:
	ORI  R17,LOW(16)
	RJMP _0x63
_0x60:
	CP   R20,R18
	BRLO _0x65
	SBRS R17,0
	RJMP _0x66
_0x65:
	RJMP _0x64
_0x66:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x67
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x63:
	SBRS R17,2
	RJMP _0x68
	ANDI R17,LOW(251)
	ST   -Y,R21
	CALL SUBOPT_0x8
	CPI  R20,0
	BREQ _0x69
	SUBI R20,LOW(1)
_0x69:
_0x68:
_0x67:
_0x5F:
	CALL SUBOPT_0x4
	CPI  R20,0
	BREQ _0x6A
	SUBI R20,LOW(1)
_0x6A:
_0x64:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x5A
	RJMP _0x59
_0x5A:
_0x57:
	SBRS R17,0
	RJMP _0x6B
_0x6C:
	CPI  R20,0
	BREQ _0x6E
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x6
	RJMP _0x6C
_0x6E:
_0x6B:
_0x6F:
_0x31:
	LDI  R16,LOW(0)
_0x1C:
	RJMP _0x17
_0x19:
	CALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	__PUTW2R 16,17
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G2
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G3:
	.BYTE 0x4

	.CSEG
__lcd_delay_G3:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	CALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G3:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G3
    ld    r26,y
    swap  r26
	CALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble_G3:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
    andi  r30,0xf0
	RET
_lcd_read_byte0_G3:
	CALL __lcd_delay_G3
	CALL __lcd_read_nibble_G3
    mov   r26,r30
	CALL __lcd_read_nibble_G3
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G3)
	SBCI R31,HIGH(-__base_y_G3)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R10,Y+1
	LDD  R11,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	CALL SUBOPT_0x9
	LDI  R30,LOW(12)
	CALL SUBOPT_0x9
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	MOV  R11,R30
	MOV  R10,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R10
	CP   R12,R10
	BRSH _0x71
	__lcd_putchar1:
	INC  R11
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R11
	CALL _lcd_gotoxy
	brts __lcd_putchar0
_0x71:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G3:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G3:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R12,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G3,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G3,3
	CALL SUBOPT_0xA
	CALL SUBOPT_0xA
	CALL SUBOPT_0xA
	CALL __long_delay_G3
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL __lcd_init_write_G3
	CALL __long_delay_G3
	LDI  R30,LOW(40)
	CALL SUBOPT_0xB
	LDI  R30,LOW(4)
	CALL SUBOPT_0xB
	LDI  R30,LOW(133)
	CALL SUBOPT_0xB
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G3
	CPI  R30,LOW(0x5)
	BREQ _0x72
	LDI  R30,LOW(0)
	RJMP _0x73
_0x72:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x73:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x0:
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	ST   -Y,R30
	CALL _lcd_gotoxy
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDS  R30,_adc_data
	LDS  R31,_adc_data+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x5:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xA:
	CALL __long_delay_G3
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xB:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay_G3

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
