/*********************************************
This program was produced by the
CodeWizardAVR V1.23.8b Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 2003-06-16
Author  : RealSYS           
Company : RealSYS          
Comments: 


Chip type           : ATmega8L
Program type        : Application
Clock frequency     : 8.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256

Connect:
PORTD(0~3) = LCD(CN31)
PORTD(4~7) = LCD(CN32)

CN33() = ADC channel 
*********************************************/

#include <mega8.h>
#include <stdio.h> 
#include <lcd.h> 
#include <delay.h>


// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x12
#endasm

#define ADC_VREF_TYPE 0x40 
#define ADC_CH_0	0x00
#define ADC_CH_1	0x01
#define ADC_CH_2	0x02
#define ADC_CH_3	0x03
#define ADC_CH_4	0x04
#define ADC_CH_5	0x05
#define ADC_CH_6	0x06
#define ADC_CH_7	0x07

char sbuf[20];
// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input|ADC_VREF_TYPE;
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

// Declare your global variables here
interrupt [TIM1_OVF] void timer1_overflow(void) {
/* Place your code here */
                           
PORTB.5 ^= 1;
}
void main(void)
{
// Declare your local variables here

TCCR1A = 0xC3;
TCCR1B = 0x01;
TCNT1H = 0x10;
TCNT1L = 0x00;


// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x04;

DDRB = 0xff;
PORTB = 0xff;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 125.000 kHz
// ADC Voltage Reference: AVCC pin
// ADC High Speed Mode: Off
// ADC Auto Trigger Source: None
ADMUX=ADC_VREF_TYPE;
ADCSRA=0x86;
SFIOR&=0xEF;

SREG = 0x80;

// LCD module initialization
lcd_init(16);

while (1)
      {
      // Place your code here
      	 read_adc(ADC_CH_0); 
      	 lcd_gotoxy(0,0);
      	 lcd_putsf("Test LCD&ADC");
      	 
      	 lcd_gotoxy(0,1);
      	 sprintf(sbuf,"Current ADC=%d",ADCW);
      	 lcd_puts(sbuf); 
      	 delay_ms(10);
      	 lcd_clear(); 
      	 OCR1A = ADCW;
      

      };
}
