/*********************************************
file name: dac1.c
BY RealSYS KCO	2001.1.2

function: D/A Converter test

AVR Chip: ATmega8535 (4MHz)
CN2(1~8):PB <==> CN20(1~8):DAC_data
CN10(5~8):PD <==> CN24(1~4):DAC_cont
*********************************************/
#include <mega8535.h>

#define	BYTE	unsigned char
#define	WORD	unsigned int

#define	DAC_A0	PORTD.4
#define	DAC_A1	PORTD.5
#define	DAC_WR	PORTD.6

int 	m_cnt=0;
void  init_port(void){
	PORTD = 0xff;
	DDRB = 0xff;		/* All output dir , 0=IN,1=OUT*/
	DDRD = 0xfe;		/* PD7(O)~PD2(O),PD1/TXD(O),PD0/RXD(I) = 0xFE */
}

void	out_dac(BYTE ch, BYTE data){
	PORTB = data;
	DAC_A0 = ch & 1;
	DAC_A1 = ch & 2;
	DAC_WR = 0;
	DAC_WR = 1;
}
void main(void){
	init_port();
	while(1){
		m_cnt++;
		out_dac(0,(BYTE)m_cnt);
		out_dac(1,(BYTE)(m_cnt>>1));
		out_dac(2,(BYTE)(~m_cnt));
		out_dac(3,(BYTE)(~m_cnt>>1));
	}
}
