/*********************************************
file name: eeprom.c
BY RealSYS KCO	2001.1.2

function: AVR EEPROM test

AVR Chip: ATmega8535 (4MHz)
cable connection:
	CN9(1~4):PC <==> CN31(1~4):LCD-con
	CN9(5~8):PC <==> CN32(5~8):LCD-dat
*********************************************/
#include <mega8535.h>     
#include <stdio.h>
#include <string.h>
#include <delay.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15	; Port C
#endasm
#include <lcd.h>

typedef	unsigned int	word;

// Declare your global variables here
char	sbuf[20];
char	ram[20];
eeprom	word e_cnt; 
eeprom	char eep[]="Hello world !!!";

void main(void)
{
// Declare your local variables here
char	eeprom *ptr_eep;	// eeprom pointer
char	*ptr_ram;			// ram pointer

// LCD module initialization
lcd_init(16);
        
// copy the string from eeprom to ram
ptr_eep = eep;
ptr_ram = ram;
while(*ptr_eep) *ptr_ram++ = *ptr_eep++;

while (1)
      {
      // Place your code here
      
		lcd_gotoxy(0,0); 
		lcd_puts(ram);		// display ram(from eeprom) string
		
      	e_cnt++;			// increment e_cnt(in eeprom)
		lcd_gotoxy(0,1);
		sprintf(sbuf,"EEP e_cnt=%04X",e_cnt);
		lcd_puts(sbuf);		// display sbuf
		
		delay_ms(500);		// 0.5 sec delay
      };
}
