/*********************************************
file name: lcd_key.c
BY RealSYS KCO	2001.1.2

function: KEY in => LCD disp

AVR Chip: ATmega8535 (4MHz)
cable connection:
	CN9(1~4):PC <==> CN31(1~4):LCD-con
	CN9(5~8):PC <==> CN32(5~8):LCD-dat
	CN2(1~8):PB <==> CN30(1~8):KEY
*********************************************/
#include <mega8535.h>
#include <stdio.h>        
#include <delay.h>

typedef	unsigned char byte;

void	sw_process(void);

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15	; Port C
#endasm
#include <lcd.h>
char	sbuf[20];

// Declare your global variables here
unsigned int m_cnt=0;

/*    ̺ */
flash byte char0[8]={
	0b0000100,
	0b0000100,
	0b0000100,
	0b0000100,
	0b0011111,
	0b0001110,
	0b0000100,
	0b0000000
};

/* function used to define user characters */
void define_char(byte flash *pc,byte char_code){
byte i,a;
	a=(char_code<<3) | 0x40;
	for (i=0; i<8; i++) lcd_write_byte(a++,*pc++);
}

void main(void)
{
// Declare your local variables here

// Port B
DDRB=0x00;
PORTB=0xff;

// LCD module initialization
lcd_init(16);

/* define user character 0 */
define_char(char0,0);

	while (1)
    {
    // Place your code here   
    	m_cnt++;
	      
    	lcd_gotoxy(0,0);
		/* display used defined char 0 */
		lcd_putchar(0);
	
    	sprintf(sbuf,"Press KEY: %04X",m_cnt);
    	lcd_puts(sbuf);                

		sw_process();
		delay_ms(100);	    
	};
}                   

void	sw_process(void){
char	tmp[17];
	if(PINB == 0xff)	sprintf(tmp," No Key Press  ");     
	else if(PINB.0==0)	sprintf(tmp,"SW8(PB.0) Press");
	else if(PINB.1==0)	sprintf(tmp,"SW7(PB.1) Press");
	else if(PINB.2==0)	sprintf(tmp,"SW6(PB.2) Press");
	else if(PINB.3==0)	sprintf(tmp,"SW5(PB.3) Press");
	else if(PINB.4==0)	sprintf(tmp,"SW4(PB.4) Press");
	else if(PINB.5==0)	sprintf(tmp,"SW3(PB.5) Press");
	else if(PINB.6==0)	sprintf(tmp,"SW2(PB.6) Press");
	else if(PINB.7==0)	sprintf(tmp,"SW1(PB.7) Press");
	
	lcd_gotoxy(0,1);
   	lcd_puts(tmp);                
}
