/*********************************************
file name: uart.c
BY RealSYS KCO	2001.1.2

function: UART rx,tx test(polling method)
		9600bps,8-data,N-parity,1-stop

AVR Chip: ATmega8535 (4MHz)
cable connection:
	CN9(1~4):PC <==> CN31(1~4):LCD-con
	CN9(5~8):PC <==> CN32(5~8):LCD-dat
	CN18(1~8):PB <==> CN30(1~4):KEY
*********************************************/
#include <mega8535.h>

// Alphanumeric LCD Module functions
#asm                                               
   .equ __lcd_port=0x15	; Port C                      
#endasm
#include <lcd.h>

// Standard Input/Output functions
#include <stdio.h>

// Declare your global variables here
char	sbuf[20];
int		m_cnt=0;

void main(void)
{
// Declare your local variables here
char	k;

// Port B
DDRB=0x00;
PORTB=0xff;

// UART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// UART Receiver: On
// UART Transmitter: On
UCSRB=0x18;
// UART Baud rate: 9600
UBRRL=25;		// for 4MHz

// LCD module initialization
lcd_init(16);
SREG=0x80;

while (1)
      {
		if(UCSRA.7){	// RX ready check
	        k=getchar();	/* receive the character */
	        putchar(k);		/* and echo it back */
	        sprintf(sbuf,"RX Data=%c(%02Xh)",k,k);
			lcd_gotoxy(0,1);
		    lcd_puts(sbuf);
    	}
 	    
        m_cnt++;               
        
        // m_cnt display on LCD
		lcd_gotoxy(0,0);
        sprintf(sbuf,"m_cnt=%04X",m_cnt);
        lcd_puts(sbuf);     
    
    	// KEY check : send to UART  & LCD disp.
    	lcd_gotoxy(12,0);
		if(PINB.0==0){
			putsf("\rSW8(PD.0) Pressed");
			lcd_putsf("SW8");
		}
		else if(PINB.1==0){
			putsf("\rSW7(PD.1) Pressed");
			lcd_putsf("SW7");
		}
		else if(PINB.2==0){
			putsf("\rSW6(PD.2) Pressed");
			lcd_putsf("SW6");
		}
		else if(PINB.3==0){
			putsf("\rSW5(PD.3) Pressed");
			lcd_putsf("SW5");
		}
		else if(PINB.4==0){
			putsf("\rSW5(PD.4) Pressed");
			lcd_putsf("SW4");
		}
		else if(PINB.5==0){
			putsf("\rSW5(PD.5) Pressed");
			lcd_putsf("SW3");
		}
		else if(PINB.6==0){
			putsf("\rSW5(PD.6) Pressed");
			lcd_putsf("SW2");
		}
		else if(PINB.7==0){
			putsf("\rSW5(PD.7) Pressed");
			lcd_putsf("SW1");
		}
      };
}
