
;CodeVisionAVR C Compiler V1.25.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny2313
;Clock frequency        : 8.000000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 50 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : No
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "dc_mot.vec"
	.INCLUDE "dc_mot.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x92)
	LDI  R29,HIGH(0x92)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x92
;       1 /*********************************************
;       2 file name: dc_mot.c
;       3 BY RealSYS KCO	2001.1.1
;       4 
;       5 function: DC Motor Speed Control using PWM duty
;       6 	PC Comm. Program : '0'=STOP ~ '9'=High speed
;       7 
;       8 AVR Chip: tiny2313 (8MHz)
;       9 
;      10 cable connection:
;      11 	CN17(4):PB <==> CN26(1):DC_mot
;      12 
;      13 	RS232(20P-CPU) <==> PC COM Port
;      14 
;      15 	CN25 <==> DC Motor
;      16 *********************************************/
;      17 #include <tiny2313.h>
;      18 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      19 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      20 	.EQU __se_bit=0x20
	.EQU __se_bit=0x20
;      21 	.EQU __sm_mask=0x50
	.EQU __sm_mask=0x50
;      22 	.EQU __sm_powerdown=0x10
	.EQU __sm_powerdown=0x10
;      23 	.EQU __sm_standby=0x40
	.EQU __sm_standby=0x40
;      24 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      25 	#endif
	#endif
;      26 #include <delay.h>
;      27 #include <stdio.h>
;      28 
;      29 #define	BYTE	unsigned char
;      30 #define	WORD	unsigned int
;      31 
;      32 /* UART Status Register */
;      33 #define    RXC     7
;      34 #define    TXC     6
;      35 #define    UDRE    5
;      36 #define    FE      4
;      37 #define    OVR     3
;      38 
;      39 BYTE	rxd;
;      40 int 	m_cnt=0;
;      41 int		t_cnt0=0;
;      42 
;      43 flash BYTE fbuf[]={"\n\rPWM output value is =>"};

	.CSEG
;      44 flash BYTE message[]={"\n\rPress KEY : '0'(Low) ~ '9'(High)"};
;      45 
;      46 void  init_port(void){
_init_port:
;      47 	PORTB = 0xff;
	LDI  R30,LOW(255)
	OUT  0x18,R30
;      48 	PORTD = 0xff;
	OUT  0x12,R30
;      49 	DDRB = 0xff;		/* All output dir , 0=IN,1=OUT*/
	OUT  0x17,R30
;      50 	DDRD = 0xfe;		/* PD6(O)~PD2(O),PD1/TXD(O),PD0/RXD(I) = 0xFE */
	LDI  R30,LOW(254)
	OUT  0x11,R30
;      51 }
	RET
;      52 void	init_timer(void){
_init_timer:
;      53 	TCCR0B = 4;			/* CK(8MHz)/256 = 31.250kHz : 32usec*/
	LDI  R30,LOW(4)
	OUT  0x33,R30
;      54 	TIMSK |= 2;			/* TOIE0 = 1 */
	IN   R30,0x39
	ORI  R30,2
	OUT  0x39,R30
;      55 	TCNT0 = -32;		/* 32usec * 32 = 1.024 msec period */
	LDI  R30,LOW(224)
	OUT  0x32,R30
;      56 
;      57 	TCCR1B = 0x01;		/* Timer1 Clock = CK */
	LDI  R30,LOW(1)
	OUT  0x2E,R30
;      58 	TCCR1A = 0x81;		/* 8bit NON-INV PWM */
	LDI  R30,LOW(129)
	OUT  0x2F,R30
;      59 	OCR1AH = 0;
	LDI  R30,LOW(0)
	OUT  0x2B,R30
;      60 	OCR1AL = 50;
	LDI  R30,LOW(50)
	OUT  0x2A,R30
;      61 
;      62 }
	RET
;      63 void	init_uart(void){
_init_uart:
;      64     UCSRA = 0xe0;        /* U2X=0 */
	LDI  R30,LOW(224)
	OUT  0xB,R30
;      65 	UBRRL = 51;      	/* 9600 bps for 8MHz */
	LDI  R30,LOW(51)
	OUT  0x9,R30
;      66 	UCSRB = 0x98;     	/* RXCIE, RXEN, TXEN*/
	LDI  R30,LOW(152)
	OUT  0xA,R30
;      67 }
	RET
;      68 void	send_char(char d){
_send_char:
;      69 	while(!(UCSRA & (1<<UDRE)));
;	d -> Y+0
_0x3:
	SBIS 0xB,5
	RJMP _0x3
;      70 	UDR = d;
	LD   R30,Y
	OUT  0xC,R30
;      71 }
	ADIW R28,1
	RET
;      72 
;      73 BYTE	receive_char(void){
;      74 	while(!(UCSRA & (1 <<RXC)));
;      75 	return UDR;
;      76 }
;      77 
;      78 void    send_string(char flash *p){
_send_string:
;      79 char    rd;
;      80     while(rd = *p++) send_char(rd);
	ST   -Y,R17
;	*p -> Y+1
;	rd -> R17
_0x9:
	RCALL SUBOPT_0x0
	BREQ _0xB
	ST   -Y,R17
	RCALL _send_char
;      81 }
	RJMP _0x9
_0xB:
	LDD  R17,Y+0
	ADIW R28,3
	RET
;      82 
;      83 interrupt [TIM0_OVF] void TIMER0_OVF0_interrupt(void)
;      84 {
_TIMER0_OVF0_interrupt:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      85 	TCNT0 = -32;		/* 32usec * 32 = 1.024 msec period */
	LDI  R30,LOW(224)
	OUT  0x32,R30
;      86 	t_cnt0++;
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
;      87 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;      88 
;      89 interrupt [USART_RXC] void UART_RX_interrupt(void)
;      90 {
_UART_RX_interrupt:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      91 	rxd=UDR;
	IN   R3,12
;      92 	send_string(fbuf);
	LDI  R30,LOW(_fbuf*2)
	LDI  R31,HIGH(_fbuf*2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_string
;      93 	switch(rxd){
	MOV  R30,R3
;      94 		case '0': OCR1AL = 0;
	CPI  R30,LOW(0x30)
	BRNE _0xF
	RJMP _0xDC
;      95 			putsf("0");
;      96 	  		break;
;      97 	  	case '1': OCR1AL = 25;
_0xF:
	CPI  R30,LOW(0x31)
	BRNE _0x10
	LDI  R30,LOW(25)
	OUT  0x2A,R30
;      98 			putsf("25");
	__POINTW1FN _0,2
	RJMP _0xDD
;      99 	  		break;
;     100 	  	case '2': OCR1AL = 50;
_0x10:
	CPI  R30,LOW(0x32)
	BRNE _0x11
	LDI  R30,LOW(50)
	OUT  0x2A,R30
;     101 			putsf("50");
	__POINTW1FN _0,5
	RJMP _0xDD
;     102 	  		break;
;     103 	  	case '3': OCR1AL = 75;
_0x11:
	CPI  R30,LOW(0x33)
	BRNE _0x12
	LDI  R30,LOW(75)
	OUT  0x2A,R30
;     104 			putsf("75");
	__POINTW1FN _0,8
	RJMP _0xDD
;     105 	  		break;
;     106 	  	case '4': OCR1AL = 100;
_0x12:
	CPI  R30,LOW(0x34)
	BRNE _0x13
	LDI  R30,LOW(100)
	OUT  0x2A,R30
;     107 			putsf("100");
	__POINTW1FN _0,11
	RJMP _0xDD
;     108 	  		break;
;     109 	  	case '5': OCR1AL = 125;
_0x13:
	CPI  R30,LOW(0x35)
	BRNE _0x14
	LDI  R30,LOW(125)
	OUT  0x2A,R30
;     110 			putsf("125");
	__POINTW1FN _0,15
	RJMP _0xDD
;     111 	  		break;
;     112 	  	case '6': OCR1AL = 150;
_0x14:
	CPI  R30,LOW(0x36)
	BRNE _0x15
	LDI  R30,LOW(150)
	OUT  0x2A,R30
;     113 			putsf("150");
	__POINTW1FN _0,19
	RJMP _0xDD
;     114 	  		break;
;     115 	  	case '7': OCR1AL = 175;
_0x15:
	CPI  R30,LOW(0x37)
	BRNE _0x16
	LDI  R30,LOW(175)
	OUT  0x2A,R30
;     116 			putsf("175");
	__POINTW1FN _0,23
	RJMP _0xDD
;     117 	  		break;
;     118 	  	case '8': OCR1AL = 200;
_0x16:
	CPI  R30,LOW(0x38)
	BRNE _0x17
	LDI  R30,LOW(200)
	OUT  0x2A,R30
;     119 			putsf("200");
	__POINTW1FN _0,27
	RJMP _0xDD
;     120 	  		break;
;     121 	  	case '9': OCR1AL = 255;
_0x17:
	CPI  R30,LOW(0x39)
	BRNE _0x19
	LDI  R30,LOW(255)
	OUT  0x2A,R30
;     122 			putsf("255");
	__POINTW1FN _0,31
	RJMP _0xDD
;     123 	  		break;
;     124 		default : OCR1AL = 0;
_0x19:
_0xDC:
	LDI  R30,LOW(0)
	OUT  0x2A,R30
;     125 			putsf("0");
	__POINTW1FN _0,0
_0xDD:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _putsf
;     126 	  		break;
;     127 	}
;     128 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     129 
;     130 void main(void){
_main:
;     131 	init_port();
	RCALL _init_port
;     132 	init_uart();
	RCALL _init_uart
;     133 	init_timer();
	RCALL _init_timer
;     134 	send_string(message);
	LDI  R30,LOW(_message*2)
	LDI  R31,HIGH(_message*2)
	RCALL SUBOPT_0x1
	RCALL _send_string
;     135 
;     136 #asm	("sei")		// global enable interrupts
	sei
;     137 
;     138 	while(1){
_0x1A:
;     139 		m_cnt++;
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
;     140 		delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x1
	RCALL _delay_ms
;     141 		printf("\n\rMain counter(m_cnt) value is %d(0x%04X)",m_cnt,m_cnt);
	__POINTW1FN _0,35
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x2
	LDI  R24,8
	RCALL _printf
	ADIW R28,10
;     142 	}
	RJMP _0x1A
;     143 }
_0x1D:
	RJMP _0x1D

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
_putsf:
	ST   -Y,R17
_0x21:
	RCALL SUBOPT_0x0
	BREQ _0x23
	ST   -Y,R17
	RCALL _putchar
	RJMP _0x21
_0x23:
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _putchar
	LDD  R17,Y+0
	ADIW R28,3
	RET
__put_G2:
	ST   -Y,R17
	LDD  R26,Y+2
	LD   R30,X
	CPI  R30,0
	BREQ _0x2B
	LDD  R26,Y+1
	LD   R30,X
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2D
	CPI  R17,2
	BRLO _0x2E
	SUBI R17,LOW(1)
	ST   X,R17
_0x2D:
	LDD  R26,Y+2
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	SUBI R30,LOW(1)
	LDD  R26,Y+3
	STD  Z+0,R26
_0x2E:
	RJMP _0x2F
_0x2B:
	LDD  R30,Y+3
	ST   -Y,R30
	RCALL _putchar
_0x2F:
	LDD  R17,Y+0
	ADIW R28,4
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
_0x30:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x32
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x36
	CPI  R18,37
	BRNE _0x37
	LDI  R17,LOW(1)
	RJMP _0x38
_0x37:
	RCALL SUBOPT_0x3
_0x38:
	RJMP _0x35
_0x36:
	CPI  R30,LOW(0x1)
	BRNE _0x39
	CPI  R18,37
	BRNE _0x3A
	RCALL SUBOPT_0x3
	RJMP _0xDE
_0x3A:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x3B
	LDI  R16,LOW(1)
	RJMP _0x35
_0x3B:
	CPI  R18,43
	BRNE _0x3C
	LDI  R20,LOW(43)
	RJMP _0x35
_0x3C:
	CPI  R18,32
	BRNE _0x3D
	LDI  R20,LOW(32)
	RJMP _0x35
_0x3D:
	RJMP _0x3E
_0x39:
	CPI  R30,LOW(0x2)
	BRNE _0x3F
_0x3E:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x40
	ORI  R16,LOW(128)
	RJMP _0x35
_0x40:
	RJMP _0x41
_0x3F:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x35
_0x41:
	CPI  R18,48
	BRLO _0x44
	CPI  R18,58
	BRLO _0x45
_0x44:
	RJMP _0x43
_0x45:
	MOV  R26,R21
	LDI  R30,LOW(10)
	RCALL __MULB12U
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x35
_0x43:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x49
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	RJMP _0x4A
_0x49:
	CPI  R30,LOW(0x73)
	BRNE _0x4C
	RCALL SUBOPT_0x4
	STD  Y+6,R30
	ST   -Y,R30
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x4D
_0x4C:
	CPI  R30,LOW(0x70)
	BRNE _0x4F
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL SUBOPT_0x1
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x4D:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x50
_0x4F:
	CPI  R30,LOW(0x64)
	BREQ _0x53
	CPI  R30,LOW(0x69)
	BRNE _0x54
_0x53:
	ORI  R16,LOW(4)
	RJMP _0x55
_0x54:
	CPI  R30,LOW(0x75)
	BRNE _0x56
_0x55:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	RCALL SUBOPT_0x7
	LDI  R17,LOW(5)
	RJMP _0x57
_0x56:
	CPI  R30,LOW(0x58)
	BRNE _0x59
	ORI  R16,LOW(8)
	RJMP _0x5A
_0x59:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x8B
_0x5A:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	RCALL SUBOPT_0x7
	LDI  R17,LOW(4)
_0x57:
	SBRS R16,2
	RJMP _0x5C
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x5D
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x8
	LDI  R20,LOW(45)
_0x5D:
	CPI  R20,0
	BREQ _0x5E
	SUBI R17,-LOW(1)
	RJMP _0x5F
_0x5E:
	ANDI R16,LOW(251)
_0x5F:
	RJMP _0x60
_0x5C:
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
_0x60:
_0x50:
	SBRC R16,0
	RJMP _0x61
_0x62:
	CP   R17,R21
	BRSH _0x64
	SBRS R16,7
	RJMP _0x65
	SBRS R16,2
	RJMP _0x66
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x67
_0x66:
	LDI  R18,LOW(48)
_0x67:
	RJMP _0x68
_0x65:
	LDI  R18,LOW(32)
_0x68:
	RCALL SUBOPT_0x3
	SUBI R21,LOW(1)
	RJMP _0x62
_0x64:
_0x61:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x69
_0x6A:
	CPI  R19,0
	BREQ _0x6C
	SBRS R16,3
	RJMP _0x6D
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RCALL SUBOPT_0x7
	SBIW R30,1
	LPM  R30,Z
	RJMP _0xDF
_0x6D:
	LDD  R26,Y+6
	LD   R30,X+
	STD  Y+6,R26
_0xDF:
	ST   -Y,R30
	RCALL SUBOPT_0x9
	CPI  R21,0
	BREQ _0x6F
	SUBI R21,LOW(1)
_0x6F:
	SUBI R19,LOW(1)
	RJMP _0x6A
_0x6C:
	RJMP _0x70
_0x69:
_0x72:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x7
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x74:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x76
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x8
	RJMP _0x74
_0x76:
	CPI  R18,58
	BRLO _0x77
	SBRS R16,3
	RJMP _0x78
	SUBI R18,-LOW(7)
	RJMP _0x79
_0x78:
	SUBI R18,-LOW(39)
_0x79:
_0x77:
	SBRC R16,4
	RJMP _0x7B
	CPI  R18,49
	BRSH _0x7D
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x7C
_0x7D:
	RJMP _0xE0
_0x7C:
	CP   R21,R19
	BRLO _0x81
	SBRS R16,0
	RJMP _0x82
_0x81:
	RJMP _0x80
_0x82:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x83
	LDI  R18,LOW(48)
_0xE0:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x84
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x9
	CPI  R21,0
	BREQ _0x85
	SUBI R21,LOW(1)
_0x85:
_0x84:
_0x83:
_0x7B:
	RCALL SUBOPT_0x3
	CPI  R21,0
	BREQ _0x86
	SUBI R21,LOW(1)
_0x86:
_0x80:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x73
	RJMP _0x72
_0x73:
_0x70:
	SBRS R16,0
	RJMP _0x87
_0x88:
	CPI  R21,0
	BREQ _0x8A
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x5
	RJMP _0x88
_0x8A:
_0x87:
_0x8B:
_0x4A:
_0xDE:
	LDI  R17,LOW(0)
_0x35:
	RJMP _0x30
_0x32:
	RCALL __LOADLOCR6
	ADIW R28,17
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,1
	ST   -Y,R17
	MOV  R26,R28
	SUBI R26,LOW(2)
	ADD  R26,R15
	MOV  R17,R26
	LDI  R30,LOW(0)
	STD  Y+1,R30
	MOV  R26,R28
	SUBI R26,-(2)
	ADD  R26,R15
	RCALL __GETW1P
	RCALL SUBOPT_0x1
	ST   -Y,R17
	MOV  R30,R28
	SUBI R30,-(4)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL __print_G2
	LDD  R17,Y+0
	ADIW R28,2
	POP  R15
	RET
_strlen:
    clr  r27
    ld   r26,y+
    clr  r30
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    inc  r30
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_p_S4C:
	.BYTE 0x1

	.CSEG

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x0:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	MOVW R30,R4
	RCALL __CWD1
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x3:
	ST   -Y,R18
	LDD  R30,Y+14
	ST   -Y,R30
	MOV  R30,R28
	SUBI R30,-(14)
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	LDD  R26,Y+14
	SUBI R26,LOW(4)
	STD  Y+14,R26
	SUBI R26,-LOW(4)
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	ST   -Y,R30
	LDD  R30,Y+14
	ST   -Y,R30
	MOV  R30,R28
	SUBI R30,-(14)
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x6:
	LDD  R26,Y+14
	SUBI R26,LOW(4)
	STD  Y+14,R26
	SUBI R26,-LOW(4)
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9:
	LDD  R30,Y+14
	ST   -Y,R30
	MOV  R30,R28
	SUBI R30,-(14)
	ST   -Y,R30
	RJMP __put_G2

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULB12U:
	MOV  R0,R26
	SUB  R26,R26
	LDI  R27,9
	RJMP __MULB12U1
__MULB12U3:
	BRCC __MULB12U2
	ADD  R26,R0
__MULB12U2:
	LSR  R26
__MULB12U1:
	ROR  R30
	DEC  R27
	BRNE __MULB12U3
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	DEC  R26
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
