/*********************************************
file name: lcd_key.c
BY RealSYS KCO	2001.1.1

function: KEY in => LCD disp

AVR Chip: tiny2313 (8MHz)
cable connection:
	CN17(1~4):PB <==> CN31(1~4):LCD-con
	CN17(5~8):PB <==> CN32(5~8):LCD-dat
	CN18(4~7):PD <==> CN30(1~4):KEY
*********************************************/
#include <tiny2313.h>
#include <stdio.h>        
#include <delay.h>

typedef	unsigned char byte;

void	sw_process(void);

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18
#endasm
#include <lcd.h>
char	sbuf[20];

// Declare your global variables here
unsigned int m_cnt=0;

/*    ̺ */
flash byte char0[8]={
	0b0000100,
	0b0000100,
	0b0000100,
	0b0000100,
	0b0011111,
	0b0001110,
	0b0000100,
	0b0000000
};

/* function used to define user characters */
void define_char(byte flash *pc,byte char_code){
byte i,a;
	a=(char_code<<3) | 0x40;
	for (i=0; i<8; i++) lcd_write_byte(a++,*pc++);
}

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B
DDRB=0x00;
PORTB=0x00;

// Port D
DDRD=0x00;
PORTD=0x00;

// LCD module initialization
lcd_init(16);

/* define user character 0 */
define_char(char0,0);

	while (1)
    {
    // Place your code here   
    	m_cnt++;
	      
    	lcd_gotoxy(0,0);
		/* display used defined char 0 */
		lcd_putchar(0);
	
    	sprintf(sbuf,"Press S/W: %04X",m_cnt);
    	lcd_puts(sbuf);                

		sw_process();
		delay_ms(100);	    
	};
}                   

void	sw_process(void){
char	tmp[17];
	if(PIND.3==0)	sprintf(tmp,"SW8(PD3) pressed");
	else if(PIND.4==0)	sprintf(tmp,"SW7(PD4) pressed");
	else if(PIND.5==0)	sprintf(tmp,"SW6(PD5) pressed");
	else if(PIND.6==0)	sprintf(tmp,"SW5(PD6) pressed");
	else sprintf(tmp," No Key pressed ");     
	
	lcd_gotoxy(0,1);
   	lcd_puts(tmp);                
}