
;CodeVisionAVR C Compiler V1.25.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny2313
;Clock frequency        : 8.000000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : No
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "step_mot.vec"
	.INCLUDE "step_mot.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x80
;       1 /*********************************************
;       2 file name: step_mot.c
;       3 BY RealSYS KCO	2001.1.1
;       4 
;       5 function: STEP Motor Control using timer compare match
;       6 	PC Comm. Program : '0'=STOP ~ '9'=High speed
;       7 
;       8 AVR Chip: tiny2313 (8MHz)
;       9 
;      10 cable connection:
;      11 	CN17(1~4):PB <==> CN23(1~8):STEP_mot
;      12 
;      13 	RS232(20P-CPU) <==> PC COM Port
;      14 
;      15 	CN19 <==> Step Motor
;      16 *********************************************/
;      17 #include <tiny2313.h>
;      18 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      19 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      20 	.EQU __se_bit=0x20
	.EQU __se_bit=0x20
;      21 	.EQU __sm_mask=0x50
	.EQU __sm_mask=0x50
;      22 	.EQU __sm_powerdown=0x10
	.EQU __sm_powerdown=0x10
;      23 	.EQU __sm_standby=0x40
	.EQU __sm_standby=0x40
;      24 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      25 	#endif
	#endif
;      26 #include <delay.h>
;      27 #include <stdio.h>
;      28 
;      29 #define	BYTE	unsigned char
;      30 #define	WORD	unsigned int
;      31 
;      32 /* UART Status Register */
;      33 #define    RXC		7
;      34 #define    TXC		6
;      35 #define    UDRE		5
;      36 #define    FE		4
;      37 #define    OVR		3
;      38 
;      39 #define	t1msec		8		/* 1000 / 128 usec = 7.8125 */
;      40 #define	t2msec		16		/* 2000 / 128 usec = 15.625 */
;      41 #define	t5msec		39		/* 5000 / 128 usec = 39.0625 */
;      42 #define	t10msec		78		/* 10000 / 128 usec = 78.125 */
;      43 #define	t20msec		156		/* 20000 / 128 usec = 156.25 */
;      44 #define	t50msec		391		/* 50000 / 128 usec = 390.625 */
;      45 #define	t100msec	781		/* 100000 / 128 usec = 781.25 */
;      46 #define	t200msec	1563	/* 200000 / 128 usec = 1562.5 */
;      47 #define	t500msec	3906	/* 500000 / 128 usec = 3906.25 */
;      48 #define	t1sec		7813	/* 1000000 / 128 usec = 7812.5 */
;      49 #define	t2sec		15625	/* 2000000 / 128 usec = 15625 */
;      50 
;      51 #define	HI_BYTE(w)	(w >> 8)
;      52 #define	LO_BYTE(w)	(w & 0xff)
;      53 
;      54 BYTE	rxd;
;      55 int 	m_cnt=0;
;      56 int		t_cnt0=0,t_cnt1=0;
;      57 
;      58 flash BYTE fbuf[]={"\n\rStep Motor Increment time is =>"};

	.CSEG
;      59 flash BYTE message[]={"\n\rPress KEY : '0'(STOP) ~ '9'(High)"};
;      60 
;      61 /************ Step motor ***************/
;      62 /*BYTE	sm_data[] = { 0x0c,0x09,0x03,0x06 };*/
;      63 BYTE	sm_data[] = { 0x01,0x02,0x04,0x08 };

	.DSEG
_sm_data:
	.BYTE 0x4
;      64 
;      65 void	step_mot(WORD val);
;      66 void  init_port(void){

	.CSEG
_init_port:
	PUSH R15
;      67 	PORTB = 0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;      68 	PORTD = 0xff;
	LDI  R30,LOW(255)
	OUT  0x12,R30
;      69 	DDRB = 0xff;		/* All output dir , 0=IN,1=OUT*/
	OUT  0x17,R30
;      70 	DDRD = 0xfe;		/* PD6(O) ~ PD2(O),PD1/TXD(O),PD0/RXD(I) = 0xFE */
	LDI  R30,LOW(254)
	OUT  0x11,R30
;      71 }
	RET
;      72 void	init_timer(void){
_init_timer:
	PUSH R15
;      73 	TCCR0B = 4;			/* CK(8MHz)/256 = 31.250kHz : 32usec*/
	LDI  R30,LOW(4)
	OUT  0x33,R30
;      74 	TIMSK |= 2;			/* TOIE0 = 1 */
	IN   R30,0x39
	ORI  R30,2
	OUT  0x39,R30
;      75 	TCNT0 = -32;		/* 32usec * 32 = 1.024 msec period */
	LDI  R30,LOW(224)
	OUT  0x32,R30
;      76 
;      77 	TCCR1B = 0x0d;		/* CTC1=1(Match clear), CK(8MHz)/1024 = 7.8125kHz : 128usec*/
	LDI  R30,LOW(13)
	OUT  0x2E,R30
;      78 	TCNT1H = 0;	TCNT1L = 0;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
	OUT  0x2C,R30
;      79 	step_mot(t100msec);
	LDI  R30,LOW(781)
	LDI  R31,HIGH(781)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;      80 }
	RET
;      81 void	init_uart(void){
_init_uart:
	PUSH R15
;      82 	UCSRA.1=0;
	CBI  0xB,1
;      83 	UBRRL = 51;      	/* 9600 bps for 8MHz */
	LDI  R30,LOW(51)
	OUT  0x9,R30
;      84 	UCSRB = 0x98;     	/* RXCIE, RXEN, TXEN*/
	LDI  R30,LOW(152)
	OUT  0xA,R30
;      85 }
	RET
;      86 void	send_char(char d){
_send_char:
	PUSH R15
;      87 	while(!(USR & (1<<UDRE)));
;	d -> Y+0
_0x6:
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x42000000
	RCALL __CPD10
	BRNE PC+2
	RJMP _0x8
	RJMP _0x6
_0x8:
;      88 	UDR = d;
	LD   R30,Y
	OUT  0xC,R30
;      89 }
	ADIW R28,1
	RET
;      90 
;      91 BYTE	receive_char(void){
_receive_char:
	PUSH R15
;      92 	while(!(USR & (1 <<RXC)));
_0x9:
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x43000000
	RCALL __CPD10
	BRNE PC+2
	RJMP _0xB
	RJMP _0x9
_0xB:
;      93 	return UDR;
	IN   R30,0xC
	RET
;      94 }
;      95 
;      96 void    send_string(char *p){
_send_string:
	PUSH R15
;      97 char    rd;
;      98     while(rd = *p++) send_char(rd);
	ST   -Y,R17
;	*p -> Y+1
;	rd -> R17
_0xC:
	LDD  R26,Y+1
	LD   R30,X+
	STD  Y+1,R26
	MOV  R17,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0xE
	ST   -Y,R17
	RCALL _send_char
;      99 }
	RJMP _0xC
_0xE:
	LDD  R17,Y+0
	ADIW R28,2
	RET
;     100 void    send_fstring(char flash *p){
_send_fstring:
	PUSH R15
;     101 char    rd;
;     102     while(rd = *p++) send_char(rd);
	ST   -Y,R17
;	*p -> Y+1
;	rd -> R17
_0xF:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x11
	ST   -Y,R17
	RCALL _send_char
;     103 }
	RJMP _0xF
_0x11:
	LDD  R17,Y+0
	ADIW R28,3
	RET
;     104 
;     105 void	step_mot(WORD val){
_step_mot:
	PUSH R15
;     106 	if(val == 0){
;	val -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,0
	BREQ PC+2
	RJMP _0x12
;     107 		TIMSK &= ~(0x40);	/* OCIE1A = 0 ; Timer/Counter1 OCM Interrupt Disable */
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;     108 		PORTB &= 0xf0;		/* Step_Mot_PIN All off(0) */
	IN   R30,0x18
	ANDI R30,LOW(0xF0)
	OUT  0x18,R30
;     109 	}
;     110 	else{
	RJMP _0x13
_0x12:
;     111 //		TCNT1H = 0;	TCNT1L = 0;
;     112 		TCNT1 = 0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
;     113 
;     114 //		OCR1AH = HI_BYTE(val);		OCR1AL = LO_BYTE(val);
;     115 		OCR1 = val;
	LD   R30,Y
	LDD  R31,Y+1
;     116 		TIMSK |= 0x40;		/* OCIE1A = 1 ; Timer/Counter1 OCM Interrupt Enable */
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;     117 	}
_0x13:
;     118 }
	ADIW R28,2
	RET
;     119 
;     120 interrupt [TIM0_OVF] void TIMER0_OVF0_interrupt(void)
;     121 {
_TIMER0_OVF0_interrupt:
;     122 	TCNT0 = -32;		/* 32usec * 32 = 1.024 msec period */
	LDI  R30,LOW(224)
	OUT  0x32,R30
;     123 	t_cnt0++;
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
;     124 }
	RETI
;     125 interrupt [TIM1_COMP] void TIMER1_COMP1_interrupt(void)
;     126 {
_TIMER1_COMP1_interrupt:
;     127 	t_cnt1++;
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
;     128 	PORTB = sm_data[t_cnt1 & 0x03];
	MOVW R30,R8
	ANDI R30,LOW(0x3)
	ANDI R31,HIGH(0x3)
	SUBI R30,-LOW(_sm_data)
	LD   R30,Z
	OUT  0x18,R30
;     129 }
	RETI
;     130 
;     131 interrupt [USART_RXC] void UART_RX_interrupt(void)
;     132 {
_UART_RX_interrupt:
;     133 	rxd=UDR;
	IN   R3,12
;     134 	putsf(fbuf);
	LDI  R30,LOW(_fbuf*2)
	LDI  R31,HIGH(_fbuf*2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _putsf
;     135 	switch(rxd){
	MOV  R30,R3
;     136 		case '0': step_mot(0);
	CPI  R30,LOW(0x30)
	BREQ PC+2
	RJMP _0x17
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;     137 			send_fstring("STOP");
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_fstring
;     138 	  		break;
	RJMP _0x16
;     139 	  	case '1': step_mot(t500msec);
_0x17:
	CPI  R30,LOW(0x31)
	BREQ PC+2
	RJMP _0x18
	LDI  R30,LOW(3906)
	LDI  R31,HIGH(3906)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;     140 			send_fstring("500msec");
	__POINTW1FN _0,5
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_fstring
;     141 	  		break;
	RJMP _0x16
;     142 	  	case '2': step_mot(t200msec);
_0x18:
	CPI  R30,LOW(0x32)
	BREQ PC+2
	RJMP _0x19
	LDI  R30,LOW(1563)
	LDI  R31,HIGH(1563)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;     143 			send_fstring("200msec");
	__POINTW1FN _0,13
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_fstring
;     144 	  		break;
	RJMP _0x16
;     145 	  	case '3': step_mot(t100msec);
_0x19:
	CPI  R30,LOW(0x33)
	BREQ PC+2
	RJMP _0x1A
	LDI  R30,LOW(781)
	LDI  R31,HIGH(781)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;     146 			send_fstring("100msec");
	__POINTW1FN _0,21
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_fstring
;     147 	  		break;
	RJMP _0x16
;     148 	  	case '4': step_mot(t50msec);
_0x1A:
	CPI  R30,LOW(0x34)
	BREQ PC+2
	RJMP _0x1B
	LDI  R30,LOW(391)
	LDI  R31,HIGH(391)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;     149 			send_fstring("50msec");
	__POINTW1FN _0,29
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_fstring
;     150 	  		break;
	RJMP _0x16
;     151 	  	case '5': step_mot(t20msec);
_0x1B:
	CPI  R30,LOW(0x35)
	BREQ PC+2
	RJMP _0x1C
	LDI  R30,LOW(156)
	LDI  R31,HIGH(156)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;     152 			send_fstring("20msec");
	__POINTW1FN _0,36
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_fstring
;     153 	  		break;
	RJMP _0x16
;     154 	  	case '6': step_mot(t10msec);
_0x1C:
	CPI  R30,LOW(0x36)
	BREQ PC+2
	RJMP _0x1D
	LDI  R30,LOW(78)
	LDI  R31,HIGH(78)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;     155 			send_fstring("10msec");
	__POINTW1FN _0,43
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_fstring
;     156 	  		break;
	RJMP _0x16
;     157 	  	case '7': step_mot(t5msec);
_0x1D:
	CPI  R30,LOW(0x37)
	BREQ PC+2
	RJMP _0x1E
	LDI  R30,LOW(39)
	LDI  R31,HIGH(39)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;     158 			send_fstring("5msec");
	__POINTW1FN _0,50
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_fstring
;     159 	  		break;
	RJMP _0x16
;     160 	  	case '8': step_mot(t2msec);
_0x1E:
	CPI  R30,LOW(0x38)
	BREQ PC+2
	RJMP _0x1F
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;     161 			send_fstring("2msec");
	__POINTW1FN _0,56
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_fstring
;     162 	  		break;
	RJMP _0x16
;     163 	  	case '9': step_mot(t1msec);
_0x1F:
	CPI  R30,LOW(0x39)
	BREQ PC+2
	RJMP _0x21
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;     164 			send_fstring("1msec");
	__POINTW1FN _0,62
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_fstring
;     165 	  		break;
	RJMP _0x16
;     166 		default : step_mot(0);
_0x21:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _step_mot
;     167 			send_fstring("STOP");
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _send_fstring
;     168 	  		break;
;     169 	}
_0x16:
;     170 }
	RETI
;     171 void main(void){
_main:
;     172 	init_port();
	RCALL _init_port
;     173 	init_uart();
	RCALL _init_uart
;     174 	init_timer();
	RCALL _init_timer
;     175 	putsf(message);
	LDI  R30,LOW(_message*2)
	LDI  R31,HIGH(_message*2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _putsf
;     176 
;     177 	#asm	("sei")		// global enable interrupts
	sei
;     178 	while(1){
_0x22:
;     179 		m_cnt++;
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
;     180 		delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     181 	}
	RJMP _0x22
_0x24:
;     182 }
_0x25:
	RJMP _0x25
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

;END OF CODE MARKER
__END_OF_CODE:
