#include <tiny2313.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18
#endasm
#include <lcd.h>

// Standard Input/Output functions
#include <stdio.h>

// Declare your global variables here
char	sbuf[20];
int		m_cnt=0;

void main(void)
{
// Declare your local variables here
char	k;

//Input/Output Ports initialization
//PORT B
DDRB=0x00;
PORTB=0x00;

//PORT D
DDRD=0x00;
PORTD=0x00;

//Timer/Couter 0 initialization
//Clock source:System Clock
//Clock value:Timer 0 Stopped
//Mode:Output Compare
//OC0 output : Disconnected
TCCR0B=0x00;
TCNT0=0x00;

//Timer/Couter 1 initialization
//Clock source:System Clock
//Clock value:Timer 1 Stopped
//Mode:Output Compare
//OC1 output : Discon.
//Noise Candceler:off
//Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;


// UART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// UART Receiver: On
// UART Transmitter: On
UCSRB=0x18;
// UART Baud rate: 9600
UCSRA=0xE0;        
UBRRL = 51;  

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;

// LCD module initialization
lcd_init(16);
         
while (1)
      {
		
		if(UCSRA.7){	    // RX ready check
	        k=getchar();	/* receive the character */
	        putchar(k);		/* and echo it back */
  	        sprintf(sbuf,"RX Data=%c(%02Xh)",k,k);
		    lcd_gotoxy(0,1); 
            lcd_puts(sbuf);
    	}
 	         
        m_cnt++;               
        
        
        // m_cnt display on LCD
 		lcd_gotoxy(0,0);
        sprintf(sbuf,"m_cnt=%04X",m_cnt);
        lcd_puts(sbuf);     
        
    	// KEY check : send to UART  & LCD disp.
   	    lcd_gotoxy(12,0);
		if(PIND.3==0){
			putsf("\rSW8(PD3) Pressed");
			lcd_putsf("SW8");
		}
		else if(PIND.4==0){
			putsf("\rSW7(PD4) Pressed");
			lcd_putsf("SW7");
		}
		else if(PIND.5==0){
			putsf("\rSW6(PD5) Pressed");
			lcd_putsf("SW6");
		}
		else if(PIND.6==0){
			putsf("\rSW5(PD6) Pressed");
			lcd_putsf("SW5");
		} 

      };
}
